#include<bits/stdc++.h>
#pragma optimise("O3")
#pragma target("sse4")
using namespace std;
const long long MAXN=100007;
int nn[MAXN];
string s,t[MAXN];
int n;
bitset<MAXN> sysht;
int main()
{
    cin>>s;
    cin>>n;
    for (int q=0;q<n;q++) cin>>t[q];
    while (true)
    {
        int ass=-1,ll=-1;
        for (int q=0;q<s.size();q++)
        {
            if (sysht[q]==1) continue;
            for (int w=0;w<n;w++)
            {
                int w70=0;
                for (int q70=q;w70<t[w].size() && q70<s.size();q70++)
                {
                    if (sysht[q70]==1) {q70=nn[q70]-1;continue;}
                    if (s[q70]!=t[w][w70]) break;
                    w70++;
                }
                if (w70==t[w].size())
                {
                    ass=q;
                    ll=t[w].size();
                    break;
                }
            }
            if (ass!=-1) break;
        }
        if (ass==-1) break;
        else
        {
            int l1=0;
            for (int q=ass;q<s.size() && l1<ll;q++)
            {
                if (sysht[q]==0)
                {
                    l1++;
                    sysht[q]=1;
                    if (q!=s.size())
                    {
                        if (sysht[q+1]==1)
                        {
                            nn[q]=nn[q+1];
                        }
                        else
                        {
                            nn[q]=q+1;
                        }
                    }
                    else
                    {
                        nn[q]=q+1;
                    }
                }
            }
        }
    }
    for (int q=0;q<s.size();q++)
    {
        if (sysht[q]==0) cout<<s[q];
    }
}
